/*
 * This file is part of the authRXBN single sign-on package.
 *
 * (c) Ruben Meyer <contact@rxbn.de>
 */

/**
 * EXPLANATIONS:
 * groups: ["anon", "user", "admin"]
 * - anon: not logged in; no cookies
 * - user: logged in; non-special group
 * - admin: logged in; admin group 999 or equivalent
 */
let rules = [
	{
		group: "anon",
		expression: "(/blocks/.*)",
		rule: "block",
		type: "404"
	},
	{
		group: "anon",
		expression: "(/error/.*)",
		rule: "block",
		type: "404"
	},
	{
		group: "user",
		expression: "(/blocks/.*)",
		rule: "block",
		type: "404"
	},
	{
		group: "user",
		expression: "(/error/.*)",
		rule: "block",
		type: "404"
	}
];

module.exports = rules;
